package seed.minerva.imse;

import seed.minerva.optics.lenses.Nikon135mmF28;
import seed.minerva.optics.lenses.Nikon50mmF11;
import seed.minerva.optics.lenses.SchneiderXenon25mmF095;

public class IMSEOptics75_25 extends IMSEOptics {
	public IMSEOptics75_25() {
	
		focalLength1 = 0.075;
		
		focalLength2 = 0.025;

		rotateObjLens = true;
		
		imgLensPlaneToCell = 0.035; //for the 25mm

		objLensPlaneToCell = rotateObjLens ? 0.060 : 0.080; //for the 75 (50 scaled)
		
		objLens = new Nikon50mmF11(new double[]{ focalLength1 + focusAdjustObj, 0, 0 }, 0.075/0.050);
		objLensCaseRadius = ((Nikon50mmF11)objLens).getCaseRadius();
		
		imgLens = new SchneiderXenon25mmF095(new double[]{ imgLensPos(), 0, 0 });
		imgLensCaseRadius = ((SchneiderXenon25mmF095)imgLens).getCaseRadius();
				
		init();
	}
}
